package com.ruoyi.web.controller.liandao;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.ruoyi.common.core.controller.BaseController;
import com.ruoyi.common.core.domain.AjaxResult;
import com.ruoyi.common.core.domain.DeleteBody;
import com.ruoyi.common.core.page.TableDataInfo;
import com.ruoyi.common.query.LambdaQueryWrapperX;
import com.ruoyi.liandao.domain.QuestionnaireConfig;
import com.ruoyi.liandao.dto.questionnaire.QuestionnaireConfigAddReqDto;
import com.ruoyi.liandao.dto.questionnaire.QuestionnaireConfigEditReqDto;
import com.ruoyi.liandao.dto.questionnaire.QuestionnaireConfigPageReqDto;
import com.ruoyi.liandao.dto.questionnaire.QuestionnaireDto;
import com.ruoyi.liandao.service.QuestionnaireConfigService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

/**
 * 问卷配置接口
 *
 * @Author : chenzhengyu
 * @create 2024/3/19 9:02
 */
@RestController
@RequestMapping("/liandao/questionnaire/config")
public class QuestionnaireConfigController extends BaseController {

    @Autowired
    private QuestionnaireConfigService configService;

    /**
     * 分页查询
     *
     * @param dto
     * @return
     */
    @GetMapping("/page")
    public TableDataInfo page(QuestionnaireConfigPageReqDto dto) {
        IPage<QuestionnaireConfig> iPage = configService.page((IPage<QuestionnaireConfig>) dto.getPage(),
                new LambdaQueryWrapperX<QuestionnaireConfig>()
                        .likeIfPresent(QuestionnaireConfig::getQuestion, dto.getQuestion())
                        .eqIfPresent(QuestionnaireConfig::getType, dto.getType())
                        .eqIfPresent(QuestionnaireConfig::getIsRequired, dto.getIsRequired())
                        .orderByAsc(QuestionnaireConfig::getOrderNum));
        return getDataTable(iPage);
    }

    /**
     * 新增
     * @param dto
     * @return
     */
    @PostMapping("/add")
    public AjaxResult add(@RequestBody QuestionnaireConfigAddReqDto dto){
        configService.add(dto);
        return success();
    }

    /**
     * 修改
     * @param dto
     * @return
     */
    @PostMapping("/edit")
    public AjaxResult edit(@RequestBody QuestionnaireConfigEditReqDto dto){
        configService.edit(dto);
        return success();
    }

    /**
     * 根据id获取详情
     * @param id
     * @return
     */
    @GetMapping("/detail")
    public AjaxResult detail(@RequestParam Long id){
        QuestionnaireDto result = configService.detail(id);
        return success(result);
    }

    /**
     * 根据id删除
     * @param deleteBody
     * @return
     */
    @PostMapping("/delete")
    public AjaxResult delete(@RequestBody DeleteBody deleteBody){
        configService.removeById(deleteBody.getId());
        return success();
    }

}
